OroApiBundle Documentation
==========================

 - [Configure Stateless Security Firewalls](./security.md)
 - [Configuration Reference](./configuration.md)
   - [**exclude** option](./configuration.md#exclude-option)
   - [**entity_aliases** configuration section](./configuration.md#entity_aliases-configuration-section)
   - [**entities** configuration section](./configuration.md#entities-configuration-section)
   - [**fields** configuration section](./configuration.md#fields-configuration-section)
   - [**filters** configuration section](./configuration.md#filters-configuration-section)
   - [**sorters** configuration section](./configuration.md#sorters-configuration-section)
   - [**actions** configuration section](./configuration.md#actions-configuration-section)
   - [**status_codes** configuration section](./configuration.md#action-status_codes-configuration-section)
   - [**subresources** configuration section](./configuration.md#subresources-configuration-section)
   - [**relations** configuration section](./configuration.md#relations-configuration-section)
 - [Documenting API Resources](./documentation.md)
   - [Overview](./documentation.md#overview)
   - [Documentation File Format](./documentation.md#documentation-file-format)
 - [Configuration Extras](./configuration_extra.md)
 - [Configuration Extensions](./configuration_extensions.md)
   - [Creating configuration extension](./configuration_extensions.md#creating-configuration-extension)
   - [Add options to existing configuration section](./configuration_extensions.md#add-options-to-existing-configuration-section)
   - [Add new configuration section](./configuration_extensions.md#add-new-configuration-section)
 - [Actions](./actions.md)
   - [**get** action](./actions.md#get-action)
   - [**get_list** action](./actions.md#get_list-action)
   - [**delete** action](./actions.md#delete-action)
   - [**delete_list** action](./actions.md#delete_list-action)
   - [**create** action](./actions.md#create-action)
   - [**update** action](./actions.md#update-action)
   - [**get_subresource** action](./actions.md#get_subresource-action)
   - [**get_relationship** action](./actions.md#get_relationship-action)
   - [**update_relationship** action](./actions.md#update_relationship-action)
   - [**add_relationship** action](./actions.md#add_relationship-action)
   - [**delete_relationship** action](./actions.md#delete_relationship-action)
   - [**customize_loaded_data** action](./actions.md#customize_loaded_data-action)
   - [**customize_form_data** action](./actions.md#customize_form_data-action)
   - [**get_config** action](./actions.md#get_config-action)
   - [**get_relation_config** action](./actions.md#get_relation_config-action)
   - [**get_metadata** action](./actions.md#get_metadata-action)
   - [**normalize_value** action](./actions.md#normalize_value-action)
   - [**collect_resources** action](./actions.md#collect_resources-action)
   - [**collect_subresources** action](./actions.md#collect_subresources-action)
   - [**Context** class](./actions.md#context-class)
   - [**SubresourceContext** class](./actions.md#subresourcecontext-class)
   - [Creating new action](./actions.md#creating-new-action)
 - [Processors](./processors.md)
   - [Creating a processor](./processors.md#creating-a-processor)
   - [Processor conditions](./processors.md#processor-conditions)
   - [Examples of processor conditions](./processors.md#examples-of-processor-conditions)
   - [Error handling](./processors.md#error-handling)
 - [Debug Commands](./debug_commands.md)
 - [**X-Include** header](./headers.md)
 - [Forms Configuration](./forms.md)
 - [How To](./how_to.md)
   - [Turn on API for entity](./how_to.md#overview)
   - [Turn on API for entity disabled in "Resources/config/oro/entity.yml"](./how_to.md#turn-on-api-for-entity-disabled-in-resourcesconfigoroentityyml)
   - [Change ACL resource for action](./how_to.md#change-acl-resource-for-action)
   - [Disable access checks for action](./how_to.md#disable-access-checks-for-action)
   - [Disable entity action](./how_to.md#disable-entity-action)
   - [Change delete handler for entity](./how_to.md#change-delete-handler-for-entity)
   - [Change the maximum number of entities that can be deleted by one request](./how_to.md#change-the-maximum-number-of-entities-that-can-be-deleted-by-one-request)
   - [Configure nested object](./how_to.md#configure-nested-object)
   - [Configure nested association](./how_to.md#configure-nested-association)
   - [Turn on Extended Many-To-One Associations](./how_to.md#turn-on-extended-many-to-one-associations)
   - [Turn on Extended Many-To-Many Associations](./how_to.md#turn-on-extended-many-to-many-associations)
   - [Turn on Extended Multiple Many-To-One Associations](./how_to.md#turn-on-extended-multiple-many-to-one-associations)
